Index: NEMO/branches/UKMO/r12083_India_uncoupled/src/OCE/DYN/dynnxt.F90
===================================================================
--- NEMO/branches/UKMO/r12083_India_uncoupled/src/OCE/DYN/dynnxt.F90	(revision 12749)
+++ NEMO/branches/UKMO/r12083_India_uncoupled/src/OCE/DYN/dynnxt.F90	(revision 12750)
@@ -397,5 +397,5 @@
 
    SUBROUTINE dyn_limit_velocity (kt) 
-      ! limits maxming vlaues of un and vn by volume courant number 
+      ! limits maximum values of un and vn by volume courant number 
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index 
       ! 
@@ -447,5 +447,5 @@
          ENDDO 
       ENDDO 
-      CALL lbc_lnk_multi( 'dynnxt', un(:,:,:), 'U',  -1., vn(:,:,:), 'V',  -1. )
+!      CALL lbc_lnk_multi( 'dynnxt', un(:,:,:), 'U',  -1., vn(:,:,:), 'V',  -1. )
  
     END SUBROUTINE dyn_limit_velocity
Index: NEMO/branches/UKMO/r12083_India_uncoupled/src/OCE/SBC/fldread.F90
===================================================================
--- NEMO/branches/UKMO/r12083_India_uncoupled/src/OCE/SBC/fldread.F90	(revision 12749)
+++ NEMO/branches/UKMO/r12083_India_uncoupled/src/OCE/SBC/fldread.F90	(revision 12750)
@@ -873,24 +873,24 @@
          !
          ! Warnings to flag differences in the input and model topgraphy - is this useful/necessary?
-         SELECT CASE( kgrd )                         
-         CASE(1)
-            IF( ABS( (zh - ht_n(ji,jj)) / ht_n(ji,jj)) * tmask(ji,jj,1) > 0.01_wp ) THEN
-               WRITE(ctmp1,"(I10.10)") jb 
-               CALL ctl_warn('fld_bdy_interp: T depths differ between grids at BDY point '//TRIM(ctmp1)//' by more than 1%')
-               !   IF(lwp) WRITE(numout,*) 'DEPTHT', zh, sum(e3t_n(ji,jj,:), mask=tmask(ji,jj,:)==1),  ht_n(ji,jj), jb, jb, ji, jj
-            ENDIF
-         CASE(2)
-            IF( ABS( (zh - hu_n(ji,jj)) * r1_hu_n(ji,jj)) * umask(ji,jj,1) > 0.01_wp ) THEN
-               WRITE(ctmp1,"(I10.10)") jb 
-               CALL ctl_warn('fld_bdy_interp: U depths differ between grids at BDY point '//TRIM(ctmp1)//' by more than 1%')
-               !   IF(lwp) WRITE(numout,*) 'DEPTHU', zh, SUM(e3u_n(ji,jj,:), mask=umask(ji,jj,:)==1),  SUM(umask(ji,jj,:)), &
-               !      &                hu_n(ji,jj), jb, jb, ji, jj, narea-1, pdta_read(jb,1,:)
-            ENDIF
-         CASE(3)
-            IF( ABS( (zh - hv_n(ji,jj)) * r1_hv_n(ji,jj)) * vmask(ji,jj,1) > 0.01_wp ) THEN
-               WRITE(ctmp1,"(I10.10)") jb
-               CALL ctl_warn('fld_bdy_interp: V depths differ between grids at BDY point '//TRIM(ctmp1)//' by more than 1%')
-            ENDIF
-         END SELECT
+!         SELECT CASE( kgrd )                         
+!         CASE(1)
+!            IF( ABS( (zh - ht_n(ji,jj)) / ht_n(ji,jj)) * tmask(ji,jj,1) > 0.01_wp ) THEN
+!               WRITE(ctmp1,"(I10.10)") jb 
+!               CALL ctl_warn('fld_bdy_interp: T depths differ between grids at BDY point '//TRIM(ctmp1)//' by more than 1%')
+!               !   IF(lwp) WRITE(numout,*) 'DEPTHT', zh, sum(e3t_n(ji,jj,:), mask=tmask(ji,jj,:)==1),  ht_n(ji,jj), jb, jb, ji, jj
+!            ENDIF
+!         CASE(2)
+!            IF( ABS( (zh - hu_n(ji,jj)) * r1_hu_n(ji,jj)) * umask(ji,jj,1) > 0.01_wp ) THEN
+!               WRITE(ctmp1,"(I10.10)") jb 
+!               CALL ctl_warn('fld_bdy_interp: U depths differ between grids at BDY point '//TRIM(ctmp1)//' by more than 1%')
+!               !   IF(lwp) WRITE(numout,*) 'DEPTHU', zh, SUM(e3u_n(ji,jj,:), mask=umask(ji,jj,:)==1),  SUM(umask(ji,jj,:)), &
+!               !      &                hu_n(ji,jj), jb, jb, ji, jj, narea-1, pdta_read(jb,1,:)
+!            ENDIF
+!         CASE(3)
+!            IF( ABS( (zh - hv_n(ji,jj)) * r1_hv_n(ji,jj)) * vmask(ji,jj,1) > 0.01_wp ) THEN
+!               WRITE(ctmp1,"(I10.10)") jb
+!               CALL ctl_warn('fld_bdy_interp: V depths differ between grids at BDY point '//TRIM(ctmp1)//' by more than 1%')
+!            ENDIF
+!         END SELECT
          !
          SELECT CASE( kgrd )                         